'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.dispatchOnMount = dispatchOnMount;

var _react = require('react');

var _Subscription = require('rxjs/Subscription');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $$reduxObservableSubscription = '@@reduxObservableSubscription';

function dispatchOnMount() {
  for (var _len = arguments.length, toDispatch = Array(_len), _key = 0; _key < _len; _key++) {
    toDispatch[_key] = arguments[_key];
  }

  return function (ComposedComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(DispatchOnMountComponent, _Component);

      function DispatchOnMountComponent() {
        _classCallCheck(this, DispatchOnMountComponent);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(DispatchOnMountComponent).apply(this, arguments));
      }

      _createClass(DispatchOnMountComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var _this2 = this;

          this[$$reduxObservableSubscription] = new _Subscription.Subscription();
          toDispatch.map(function (a) {
            return _this2.context.store.dispatch(a);
          }).forEach(function (sub) {
            return sub && _this2[$$reduxObservableSubscription].add(sub);
          });
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this[$$reduxObservableSubscription].unsubscribe();
        }
      }, {
        key: 'render',
        value: function render() {
          return React.createElement(ComposedComponent, this.props);
        }
      }]);

      return DispatchOnMountComponent;
    }(_react.Component), _class.contextTypes = {
      store: _react.PropTypes.object.isRequired
    }, _temp;
  };
}